/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package br.com.topologica.vo;

import com.thoughtworks.xstream.annotations.XStreamAlias;
import com.thoughtworks.xstream.annotations.XStreamAsAttribute;
import java.beans.PropertyChangeListener;
import java.beans.PropertyChangeSupport;
import java.io.Serializable;
import java.text.SimpleDateFormat;
import java.util.Date;

/**
 *
 * @author Shalmany
 */

@XStreamAlias(value="veiculo")
public class Vehicle implements Serializable{
    private static final long serialVersionUID = 1L;

    private String name;
    
    private String placa;
    private String renavam;
    private Double speed;

    private String current;

    protected String altitude;

     protected String  tipo ;

     protected String    marca ;

      protected String   modelo ;

      protected String   ano ;
      protected String renavan;

      @XStreamAsAttribute
      protected String id;

      protected Gps gps;

      private double latitude;
      private double longitude;

    public double getLatitude() {
        return latitude;
    }

    public void setLatitude(double latitude) {
        double oldValue = this.latitude;
        this.latitude = latitude;
        propertyChangeSupport.firePropertyChange("latitude", oldValue, latitude);
    }

    public double getLongitude() {
        return longitude;
    }

    public void setLongitude(double longitude) {
         double oldValue = this.longitude;
        this.longitude = longitude;
        propertyChangeSupport.firePropertyChange("longitude", oldValue, longitude);
    }

      private PropertyChangeSupport propertyChangeSupport ;

      public Vehicle(){
            propertyChangeSupport = new PropertyChangeSupport(this);
      }

    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

    public String getRenavan() {
        return renavan;
    }

    public void setRenavan(String renavan) {
        this.renavan = renavan;
    }

    public Gps getGps() {
        return gps;
    }

    public void setGps(Gps gps) {
        this.gps = gps;
    }

    public String getAno() {
        return ano;
    }

    public void setAno(String ano) {
        this.ano = ano;
    }

    public String getMarca() {
        return marca;
    }

    public void setMarca(String marca) {
        this.marca = marca;
    }

    public String getModelo() {
        return modelo;
    }

    public void setModelo(String modelo) {
        this.modelo = modelo;
    }

    public String getTipo() {
        return tipo;
    }

    public void setTipo(String tipo) {
        this.tipo = tipo;
    }

    /**
     * Get the value of altitude
     *
     * @return the value of altitude
     */
    public String getAltitude() {
        return altitude;
    }

    /**
     * Set the value of altitude
     *
     * @param altitude new value of altitude
     */
    public void setAltitude(String altitude) {
        
        String oldValue = this.altitude;
        this.altitude = altitude;
        propertyChangeSupport.firePropertyChange("altitude", oldValue, altitude);
    }


   private String dateFormat;
    private Date date;

    public String getDateFormat() {
        return dateFormat;
    }

    public void setDateFormat(String dateFormat) {
         System.out.println(id+" : dateFormat:" + dateFormat);
        String oldValue = this.dateFormat;
        this.dateFormat = dateFormat;
        propertyChangeSupport.firePropertyChange("dateFormat", oldValue, dateFormat);
    }

  

    public Date getDate() {
        return date;
    }

    public void setDate(Date date) {
        this.date = date;
        SimpleDateFormat sdf = new SimpleDateFormat("dd-MM-yy hh:mm:ss");
        setDateFormat(sdf.format(date));

    }

   

    public String getName() {
        return name;
    }

    public void setName(String name) {
     

         String oldName = this.name;
        this.name = name;
        propertyChangeSupport.firePropertyChange("name", oldName, name);
    }

     public String getCurrent() {
        return current;
    }

    public void setCurrent(String newCurrent) {
        String oldValue = this.current;
        this.current = newCurrent;
        propertyChangeSupport.firePropertyChange("current", oldValue, newCurrent);
    }

    public String getPlaca() {
        return placa;
    }

    public void setPlaca(String placa) {
        this.placa = placa;
    }

    public String getRenavam() {
        return renavam;
    }

    public void setRenavam(String renavam) {
        this.renavam = renavam;
    }

    public Double getSpeed() {
        return speed;
    }

    public void setSpeed(Double speed) {
        Double oldValue = this.speed;
        this.speed = speed;
    if(propertyChangeSupport == null){
         propertyChangeSupport = new PropertyChangeSupport(this);
     }
        propertyChangeSupport.firePropertyChange("speed", oldValue, speed);
    }

    @Override
    public String toString() {
        return placa;
    }


public void addPropertyChangeListener(PropertyChangeListener listener) {
     if(propertyChangeSupport == null){
         propertyChangeSupport = new PropertyChangeSupport(this);
     }
        propertyChangeSupport.addPropertyChangeListener(listener);
    }

    public void removePropertyChangeListener(PropertyChangeListener listener) {
        propertyChangeSupport.removePropertyChangeListener(listener);
    }


     @Override
    public int hashCode() {
        int hash = 0;
        //hash += (customerId != null ? customerId.hashCode() : 0);
        return hash;
    }

    @Override
    public boolean equals(Object object) {
       
        return true;
    }


}
